
BaleLoaderExtended = {}
BaleLoaderExtended.debug = false

function BaleLoaderExtended.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(BaleLoader, specializations)
end

function BaleLoaderExtended:load(savegame)
    self.BaleLoaderExtended = {}
    local spec = self.BaleLoaderExtended;

    spec.speedLimit = self.speedLimit;
    --self.emptyStateExtended = 0;


end

function BaleLoaderExtended:delete()
end

function BaleLoaderExtended:readStream(streamId, connection)
end

function BaleLoaderExtended:writeStream(streamId, connection)
end

function BaleLoaderExtended:mouseEvent(posX, posY, isDown, isUp, button)
end

function BaleLoaderExtended:keyEvent(unicode, sym, modifier, isDown)
end

function BaleLoaderExtended:update(dt)
end

function BaleLoaderExtended:updateTick(dt)
    local spec = self.BaleLoaderExtended;

    --self.doStateChange

    if self.isServer then

        if BaleLoaderExtended.debug then
            --print("")
            --print(string.format("self.emptyState: %s", self.emptyState))
            --print(string.format("Capacity: %s", self:getFillLevel(self.baleDummyFillType)))
            --print(string.format("MaxCapacity: %s", self:getCapacity(self.baleDummyFillType)))
        end

        if self.emptyState == BaleLoader.EMPTY_NONE and self:getFillLevel(self.baleDummyFillType) == self:getCapacity(self.baleDummyFillType) and BaleLoader.getAllowsStartUnloading(self) and not self:getIsAnimationPlaying("moveBalePlaces") then

            if BaleLoaderExtended.debug then
                print("EMPTY_NONE")
            end
            self:doStateChange(BaleLoader.CHANGE_BUTTON_EMPTY)

        elseif self.emptyState == BaleLoader.EMPTY_WAIT_TO_DROP then

            if BaleLoaderExtended.debug then
                print("EMPTY_WAIT_TO_DROP")
            end
            self:doStateChange(BaleLoader.CHANGE_BUTTON_EMPTY)

        elseif self.emptyState == BaleLoader.EMPTY_WAIT_TO_SINK then

            if BaleLoaderExtended.debug then
                print("EMPTY_WAIT_TO_SINK")
            end
            self:doStateChange(BaleLoader.CHANGE_BUTTON_EMPTY)

        elseif self.emptyState == BaleLoader.EMPTY_SINK then

            if BaleLoaderExtended.debug then
                print("EMPTY_SINK")
            end
            self:doStateChange(BaleLoader.CHANGE_BUTTON_EMPTY)

        end

        self.speedLimit = 3;

        if self.isInWorkPosition then
            --self.speedLimit = 3;
        else
            --self.speedLimit = spec.speedLimit;
        end

    end

    --[[
    BaleLoader.EMPTY_NONE = 1;
    BaleLoader.EMPTY_WAIT_TO_DROP = 9;
    BaleLoader.EMPTY_WAIT_TO_SINK = 10;
    BaleLoader.EMPTY_SINK = 11;
    ]]

end

function BaleLoaderExtended:draw()
end
